#include <errno.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __cplusplus
#define UNSAFE_START \
  _Pragma ("GCC diagnostic push") _Pragma ("GCC diagnostic ignored \"-Wsign-conversion\"") \
      _Pragma ("GCC diagnostic ignored \"-Wold-style-cast\"")
#else
#define UNSAFE_START \
  _Pragma ("GCC diagnostic push") _Pragma ("GCC diagnostic ignored \"-Wsign-conversion\"")
#endif

#define UNSAFE_END _Pragma ("GCC diagnostic pop")

#define autofree __attribute__ ((cleanup (cleanup_free)))

static bool enable_debug = false;

__attribute__ ((__format__ (printf, 1, 2))) static void
debug (const char *format, ...)
{
  if (enable_debug)
    {
      va_list args;
      va_start (args, format);
      vprintf (format, args);
      printf ("\n");
      va_end (args);
    }
}

__attribute__ ((__format__ (printf, 1, 2))) static void
perrorf (const char *format, ...)
{
  va_list args;
  va_start (args, format);
  vfprintf (stderr, format, args);
  fprintf (stderr, ": %s\n", strerror (errno));
  va_end (args);
}

static inline void
cleanup_free (void *p)
{
  UNSAFE_START
  free (*(void **)p);
  UNSAFE_END
}
